//---------------------------------------------------------------------------
//CtQ[̃Tv
//---------------------------------------------------------------------------
#include <vcl.h>
#include <math.hpp>
#pragma hdrstop

#include "Main.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TfrmMain *frmMain;
//---------------------------------------------------------------------------
__fastcall TfrmMain::TfrmMain(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
//tH[쐬
void __fastcall TfrmMain::FormCreate(TObject *Sender)
{
	//̏
	Randomize();

	//o
	memset(mBoardBuf, 0, sizeof(mBoardBuf));
	mTransEnabled = false;
	memset(&mHideRect, -1, sizeof(mHideRect));
}
//---------------------------------------------------------------------------
//{^FRandom & Start
void __fastcall TfrmMain::btnRandStartClick(TObject *Sender)
{
	//_ɔzu
	int maxcnt = edtInitCnt->Text.ToIntDef(200);
	for (int cnt = 0; cnt < maxcnt; cnt++) {
		int posx = RandomRange(0, (MAX_COL-1));
		int posy = RandomRange(0, (MAX_ROW-1));
		mBoardBuf[posx][posy] = 1;
	}

	//Jn
	Timer1->Enabled = true;
}
//---------------------------------------------------------------------------
//{^FStart
void __fastcall TfrmMain::btnStartClick(TObject *Sender)
{
	//Jn
	Timer1->Enabled = true;
}
//---------------------------------------------------------------------------
//{^FStop
void __fastcall TfrmMain::btnStopClick(TObject *Sender)
{
	//~
	mTransEnabled = false;
	Timer1->Enabled = false;
}
//---------------------------------------------------------------------------
//{^FClear
void __fastcall TfrmMain::btnClearClick(TObject *Sender)
{
	//ꎞ̈̃NA
	memset(mBoardBuf, 0, sizeof(mBoardBuf));

	//~ł΍ĕ`悷
	if (mTransEnabled == false) {
		DrawLife();
	}
}
//---------------------------------------------------------------------------
//^C}[Cxg
void __fastcall TfrmMain::Timer1Timer(TObject *Sender)
{
	Timer1->Enabled = false;
	mTransEnabled = true;

	try {
		DrawLife();		//`
		TransLife();	//^ŏ

	}__finally{
		Timer1->Enabled = (mTransEnabled == true) ? true : false;
		mTransEnabled = false;
	}
}
//---------------------------------------------------------------------------
//StringGrid`掞
void __fastcall TfrmMain::sgBoardDrawCell(TObject *Sender, int ACol,
	  int ARow, TRect &Rect, TGridDrawState State)
{
	//sgBoardnCCg\
	sgBoard->Selection = mHideRect;
}
//---------------------------------------------------------------------------
//tH[\
void __fastcall TfrmMain::FormShow(TObject *Sender)
{
	//sgBoardnCCg\
	sgBoard->Selection = mHideRect;
}
//---------------------------------------------------------------------------
//`
void __fastcall TfrmMain::DrawLife(void)
{
	for (int posx = 0; posx < MAX_COL; posx++) {
		for (int posy = 0; posy < MAX_ROW; posy++) {
			sgBoard->Cells[posx][posy] = (mBoardBuf[posx][posy] == 1) ? "" : "";
		}
	}
}
//---------------------------------------------------------------------------
//^ŏ
void __fastcall TfrmMain::TransLife(void)
{
	//ꎞ̈̃NA
	memset(mBoardBuf, 0, sizeof(mBoardBuf));

	for (int posx = 0; posx < MAX_COL; posx++) {
		for (int posy = 0; posy < MAX_ROW; posy++) {
			//͂̐擾
			int lifecnt = 0;
			for (int chkx = -1; chkx <= 1; chkx++) {
				for (int chky = -1; chky <= 1; chky++) {
					//݂̃ZɂꍇAZ̃`FbNXLbv
					if (posx == 0 && posy == 0 && chkx == -1 && chky == -1) continue;

					//݂̃ZɂꍇAZ̃`FbNXLbv
					if (posy == 0 && chky == -1) continue;

					//݂̃ZEɂꍇAEZ̃`FbNXLbv
					if (posx == (MAX_COL-1) && posy == 0 && chkx == 1) continue;

					//݂̃ZɂꍇAZ̃`FbNXLbv
					if (posx == 0 && chkx == -1) continue;

					//݂̃Zg̃`FbN̓XLbv
					if (chkx == 0 && chky == 0) continue;

					//݂̃ZEɂꍇAEZ̃`FbNXLbv
					if (posx == (MAX_COL-1) && chkx == 1) continue;

					//݂̃ZɂꍇAZ̃`FbNXLbv
					if (posx == 0 && posy == (MAX_ROW-1) && chkx == -1 && chky == 1) continue;

					//݂̃ZɂꍇAZ̃`FbNXLbv
					if (posy == (MAX_ROW-1) && chky == 1) continue;

					//݂̃ZEɂꍇAEZ̃`FbNXLbv
					if (posx == (MAX_COL-1) && posy == (MAX_ROW-1) && chkx == 1 && chky == 1) continue;

					//ĂJEgAbv
					if (sgBoard->Cells[posx + chkx][posy + chky] != "") {
						lifecnt++;
					}
				}
			}

			//
			if (sgBoard->Cells[posx][posy] == "") {
				//Ώۂ̃Z͓YZ͏Œ
				if (lifecnt == 3) {
					//łĂZ̎͂ɂR̃ZĂꍇ
					//̐Œa
					mBoardBuf[posx][posy] = 1;
				}
			} else {
				//Ώۂ̃Z͐
				if (lifecnt == 2 || lifecnt == 3) {
					//ĂZ̎͂ɂQR̃ZĂꍇ
					//̐ł
					mBoardBuf[posx][posy] = 1;
				}
			}
		}
	}
}
//---------------------------------------------------------------------------
//}EXJ[\ړ
void __fastcall TfrmMain::sgBoardMouseMove(TObject *Sender,
	  TShiftState Shift, int X, int Y)
{
	int posx, posy;
	sgBoard->MouseToCell(X, Y, posx, posy);

	if (Shift.Contains(ssLeft) == true) {
		//NbNŒa
		mBoardBuf[posx][posy] = 1;
		sgBoard->Cells[posx][posy] = "";
	}else
	if (Shift.Contains(ssRight) == true) {
		//ENbNŏ
		mBoardBuf[posx][posy] = 0;
		sgBoard->Cells[posx][posy] = "";
	}
}
//---------------------------------------------------------------------------
//}EXNbN
void __fastcall TfrmMain::sgBoardMouseUp(TObject *Sender,
	  TMouseButton Button, TShiftState Shift, int X, int Y)
{
	int posx, posy;
	sgBoard->MouseToCell(X, Y, posx, posy);

	if (Button == mbLeft) {
		//NbNŒa
		mBoardBuf[posx][posy] = 1;
		sgBoard->Cells[posx][posy] = "";
	}else
	if (Button == mbRight) {
		//ENbNŏ
		mBoardBuf[posx][posy] = 0;
		sgBoard->Cells[posx][posy] = "";
	}
}
//---------------------------------------------------------------------------

